import cv2
import mediapipe as mp
import pandas as pd
import pickle
from math import *
import warnings
from random import choice
from itertools import cycle
from time import sleep, time
from PIL import Image
import matplotlib.pyplot as plt
import matplotlib.image as mpimg


warnings.filterwarnings('ignore')

zapis = False


def imshow(title, path):
    img = mpimg.imread(path)
    imgplot = plt.imshow(img)
    plt.show()


def frame(img, letter):
    imgRGB = cv2.cvtColor(img, cv2.COLOR_BGR2RGB)  # преобразуем кадр в RGB
    results = hands.process(imgRGB)  # получаем результат распознавания
    if results.multi_hand_landmarks is None:
        return
    for handLms in results.multi_hand_landmarks:
        d = sqrt((handLms.landmark[20].x - handLms.landmark[19].x) ** 2 + (
                handLms.landmark[20].y - handLms.landmark[19].y) ** 2)
        min_x, max_x, min_y, max_y = (1, 0, 1, 0)
        for point in handLms.landmark:
            x, y = point.x, point.y
            max_x = max(x, max_x)
            max_y = max(y, max_y)
            min_x = min(x, min_x)
            min_y = min(y, min_y)
        max_y += d
        max_x += d
        min_x -= d
        min_y -= d
        min_x = max(0, min_x)
        min_y = max(0, min_y)
        max_x = min(1, max_x)
        max_y = min(1, max_y)

        cv2.rectangle(
            img,
            (int(min_x * len(img[0])), int(min_y * len(img))),
            (int(max_x * len(img[0])), int(max_y * len(img))),
            (0, 0, 255),
            2)
        font = cv2.FONT_HERSHEY_COMPLEX

        # org
        org = (int((max_x + 0.02) * len(img[0])), int(min_y * len(img)))

        # fontScale
        fontScale = 3

        # Red color in BGR
        color = (0, 0, 255)

        # Line thickness of 2 px
        thickness = 3

        # Using cv2.putText() method
        cv2.putText(img, letter, org, font,
                    fontScale, color, thickness, cv2.LINE_AA)


def what_letter(img):
    imgRGB = cv2.cvtColor(img, cv2.COLOR_BGR2RGB)  # преобразуем кадр в RGB
    results = hands.process(imgRGB)  # получаем результат распознавания
    if results.multi_hand_landmarks:
        handLms = results.multi_hand_landmarks[0]  # получаем координаты каждой точки
        # mpDraw.draw_landmarks(img, handLms, mpHands.HAND_CONNECTIONS)
        p = {'letter': 'q'}
        train = pd.DataFrame()
        df = pd.DataFrame(columns=col)

        for id, point in enumerate(handLms.landmark):
            p[f'id{id}x'] = point.x
            p[f'id{id}y'] = point.y
        df.loc[len(df)] = p

        for i in range(1, 21):
            train[f'len0-{i}'] = ((df.id0x - df[f'id{i}x']) ** 2 + (df.id0y - df[f'id{i}y']) ** 2) ** 0.5 / (
                    (df.id0x - df[f'id{9}x']) ** 2 + (df.id0y - df[f'id{9}y']) ** 2) ** 0.5

        train[f'len4-8'] = ((df.id4x - df.id8x) ** 2 + (df.id4y - df.id8y) ** 2) ** 0.5 / (
                (df.id0x - df[f'id{9}x']) ** 2 + (df.id0y - df[f'id{9}y']) ** 2) ** 0.5
        train[f'len8-12'] = ((df.id12x - df.id8x) ** 2 + (df.id12y - df.id8y) ** 2) ** 0.5 / (
                (df.id0x - df[f'id{9}x']) ** 2 + (df.id0y - df[f'id{9}y']) ** 2) ** 0.5
        train[f'len12-16'] = ((df.id12x - df.id16x) ** 2 + (df.id12y - df.id16y) ** 2) ** 0.5 / (
                (df.id0x - df[f'id{9}x']) ** 2 + (df.id0y - df[f'id{9}y']) ** 2) ** 0.5
        train[f'len16-20'] = ((df.id16x - df.id20x) ** 2 + (df.id16y - df.id20y) ** 2) ** 0.5 / (
                (df.id0x - df[f'id{9}x']) ** 2 + (df.id0y - df[f'id{9}y']) ** 2) ** 0.5
        train[f'len20-4'] = ((df.id4x - df.id20x) ** 2 + (df.id4y - df.id20y) ** 2) ** 0.5 / (
                (df.id0x - df[f'id{9}x']) ** 2 + (df.id0y - df[f'id{9}y']) ** 2) ** 0.5

        train[f'len17-4'] = ((df.id4x - df.id17x) ** 2 + (df.id4y - df.id17y) ** 2) ** 0.5 / (
                (df.id0x - df[f'id{9}x']) ** 2 + (df.id0y - df[f'id{9}y']) ** 2) ** 0.5

        try:
            return chr(model.predict(train)[0])
        except:
            pass
    else:
        return ''


with open('clf.pkl', 'rb') as file:
    model = pickle.load(file)

dict_of = dict(zip(list("qwertyuiop[]asdfghjkl;'zxcvbnm,."), list('йцукенгшщзхъфывапролджэячсмитьбю')))
camera = cv2.VideoCapture(0)
mpHands = mp.solutions.hands
hands = mpHands.Hands()  # создаем объект класса "руки"
mpDraw = mp.solutions.drawing_utils


def distance(point1, point2):
    return abs(point1 - point2)


col = ['letter']
for id in range(21):
    col.append(f'id{id}x')
    col.append(f'id{id}y')

df = pd.DataFrame(columns=col)
slovo = ''
last = ''
sp = ['', '', '', '', '']
slova = ['сок', 'сова']
if zapis:
    output = cv2.VideoWriter('output_video_from_file.mp4', cv2.VideoWriter_fourcc(*'XVID'), 10, (1200, 800))
for zag in cycle(slova):
    cv2.destroyAllWindows()
    imshow('zagadka', zag + '.jpg')
    sleep(6)
    slovo = ''
    last = ''
    sp = ['', '', '', '', '']
    flag = False
    while True:
        if flag:
            if time() - start >= 3:
                break
        good, img = camera.read()
        img = cv2.resize(img, (1200, 800))
        imgRGB = cv2.cvtColor(img, cv2.COLOR_BGR2RGB)  # преобразуем кадр в RGB
        results = hands.process(imgRGB)  # получаем результат распознавания
        if results.multi_hand_landmarks:
            handLms = results.multi_hand_landmarks[0]
            letter = what_letter(img)
            frame(img, letter)
            mpDraw.draw_landmarks(img, handLms, mpHands.HAND_CONNECTIONS)
            cv2.circle(img, (int(handLms.landmark[9].x * len(img[0])), int(handLms.landmark[9].y * len(img))), 4,
                       (255, 255, 0), -1)
            if zapis:
                output.write(img)
            del sp[0]
            sp.append(letter)
            nre = list(sorted(sp))[len(sp) // 2]
            if nre == letter != last:
                last = letter
                slovo += last
            # print(sp)

            font = cv2.FONT_HERSHEY_COMPLEX
            org = (int(0.2 * len(img[0])), int(0.8 * len(img)))
            fontScale = 3
            color = (0, 0, 255)
            thickness = 3
            if slovo != zag:
                if len(slovo) < len(zag):
                    cv2.putText(img, slovo, org, font,
                                fontScale, color, thickness, cv2.LINE_AA)
                else:
                    cv2.putText(img, slovo, org, font,
                                fontScale, color, thickness, cv2.LINE_AA)

                    cv2.putText(img, 'еще раз', (org[0], org[1] + 55), font,
                                fontScale, color, thickness, cv2.LINE_AA)
            if slovo == zag:
                cv2.putText(img, slovo, org, font,
                            fontScale, color, thickness, cv2.LINE_AA)
                cv2.putText(img, 'молодец', (org[0], org[1] + 45), font,
                            fontScale, (0, 255, 0), thickness, cv2.LINE_AA)
                if not flag:
                    start = time()
                flag = True
        else:
            sp = ['', '', '', '', '']
            slovo = ''
            last = ''

        cv2.imshow("Image", img)

        if cv2.waitKey(1) == ord('q'):
            if zapis:
                output.release()
            exit()
